package czerwony.kapturek.jbwheel;

import java.io.*;
import java.util.*;
import java.util.zip.*;

public final class ClassDirFinder
{
	public static String find(String className)
	{
		try
		{
			String classPath = System.getProperty("java.class.path");
			String classFile = className.replace('.', File.separatorChar ) + ".class";
			String classEntry = className.replace('.', '/') + ".class";
			StringTokenizer st = new StringTokenizer(classPath, File.pathSeparator);

			while (st.hasMoreTokens())
			{
				String dirName = st.nextToken();
				if (dirName.endsWith(File.separator))
				{
					dirName = dirName.substring(0, dirName.lastIndexOf(File.separator));
				}
				File dirFile = new File(dirName);
				if (dirFile.isDirectory())
				{
					String filename = dirName + File.separatorChar + classFile;
					if (new File(filename).exists())
						return dirName;
				}
				else if (dirFile.isFile())
				{
					ZipFile zf = new ZipFile(dirFile);
					Enumeration e = zf.entries();
					String entryName;
					while (e.hasMoreElements())
					{
						entryName = ((ZipEntry)e.nextElement()).getName();
						if (entryName.equals(classEntry))
						{
							int index = dirName.lastIndexOf(File.separator);
							if (index != -1)
								return dirName.substring(0, dirName.lastIndexOf(File.separator));
							return ".";
						}
					}
				}
			}
		}
		catch (Exception e)
		{
			e.printStackTrace(System.err);
		}

		// class file not found. guess ?
		return ".";
	}
}

