#define _WIN32_WINDOWS 0x0444
#include <windows.h>
#include "zmouse.h"
#include "czerwony_kapturek_jbwheel_WheelTool.h"

HANDLE hm;
HANDLE console;
HHOOK hh;
DWORD myProcess;

UINT uMSH_MOUSEWHEEL = 0;

jobject jo;
JNIEnv * env = NULL;
JavaVM* vm;
jmethodID mid;

void trace( char* msg );

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID /*lpReserved*/
					 )
{
	hm = hModule;
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
			break;
			
		case DLL_PROCESS_DETACH:
			if (hh)
			{
				if ( console )
					FreeConsole();
				::UnhookWindowsHookEx( hh );
				hh = 0;
			}
			break;
    }
    return TRUE;
}


long _stdcall hookProc( int code, unsigned int wParam, long lParam )
{
	if ( code>=0 )
	{
		MSG* pMsg = (MSG*)lParam;
		DWORD process;
		GetWindowThreadProcessId( pMsg->hwnd, &process ); 
		if ( process == myProcess && ( pMsg->message == WM_MOUSEWHEEL
			|| pMsg->message == uMSH_MOUSEWHEEL ) )
		{
			bool mw = pMsg->message == WM_MOUSEWHEEL;
			trace( mw ? "WM_MOUSEWHEEL\n" : "MSH_MOUSEWHEEL\n" );
			if ( !env )
			{
				int qq = vm->AttachCurrentThread( (void**)&env, NULL );
			//}
				// I'm not sure if storing method ID is valid
				jclass jc = env->GetObjectClass( jo );
				mid = env->GetMethodID( jc, "onWheelMoved", "(IIII)V");
			}
			
			short delta = 0;
			short keys = 0;
			if ( mw )
			{
				delta = (short)HIWORD(pMsg->wParam);
				keys = (short)LOWORD(pMsg->wParam);
			}
			else
			{
				if ( GetKeyState( VK_SHIFT )&0xFF00 )
					keys |= MK_SHIFT;
				if ( GetKeyState( VK_CONTROL )&0xFF00 )
					keys |= MK_CONTROL;
				delta = (short)pMsg->wParam;
			}
			
			env->CallVoidMethod( jo, mid, 
						delta,
						(short)LOWORD(pMsg->lParam),
						(short)HIWORD(pMsg->lParam),
						keys /*+ (alt ? 0x8000 : 0)*/ );
		}
	}
	return CallNextHookEx( hh, code, wParam, lParam );
}

/*
 * Class:     czerwony_kapturek_jbwheel_WheelTool
 * Method:    startCaptureWheelMessages
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_czerwony_kapturek_jbwheel_WheelTool_startCaptureWheelMessages
  (JNIEnv * env1, jobject jo1, jboolean debug )
{
	console = NULL;
	if ( debug )
	{
		AllocConsole();
		console = GetStdHandle( STD_ERROR_HANDLE );
		trace( "console allocated\n" );
	}

	uMSH_MOUSEWHEEL = RegisterWindowMessage(MSH_MOUSEWHEEL);
      
	jo = env1->NewGlobalRef( jo1 );
	env1->GetJavaVM( &vm );

	hh = ::SetWindowsHookEx( WH_GETMESSAGE, hookProc, (HINSTANCE)hm, NULL );
	if (!hh)
	{
		char	buff[255];
		wsprintf( buff, "Failed to register message hook (%08X)\n", GetLastError() );
		trace( buff );
	}
	myProcess = ::GetCurrentProcessId();

	//printf( "\nDZIALAM 0x%08X\n", hh );
}

/*
 * Class:     czerwony_kapturek_jbwheel_WheelTool
 * Method:    stopCaptureWheelMessages
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_czerwony_kapturek_jbwheel_WheelTool_stopCaptureWheelMessages
  (JNIEnv *, jobject)
{
	if ( console )
		FreeConsole();
	env->DeleteGlobalRef( jo );
	jo = NULL;
	env = NULL;
	vm = NULL;
	mid = 0;
	if (hh)
	{
		::UnhookWindowsHookEx( hh );
		hh = 0;
	}
}

void trace( char* msg )
{
	if ( console )
		printf( msg );
}



